# MQTTController Change Log

Online docs: https://reactor.toggledbits.com/docs/MQTTController/

**Versions >=22305 require Reactor build 22305 or higher.**

## 22350

* Improve handling of `x_mqtt_device.online` attribute for templates that have custom LWT event.

## 22341

* Polling support. [[docs](https://reactor.toggledbits.com/docs/MQTTController/#polling)]
* Implement `sys_system.restart` action.
* Doc recommendations for publishing templates to the community.

## 22340

* Fix an error in the `x_mqtt_system.publish` action could cause a reaction task to stall.
* The `query` configuration key now takes either a string as a simple topic to be sent with no payload and default QoS/retain, or an object that contains a required key `topic` (string value) and the optional keys `payload`, `qos` and `retain`. These keys have the same meaning as the array entries of `init` (but note that `query` is not an array; only a single topic/payload can be defined). [[docs](https://reactor.toggledbits.com/docs/MQTTController/#additional-entity-configuration)]

## 22337

* New configuration `default_qos` and `default_retain` establish the top of a hierarchy for setting QoS and retain flags. Refer to the [[docs](https://reactor.toggledbits.com/docs/MQTTController/#qos-and-retain)] for details.
* Implement a detection and timeout mechanism for topics sent in QoS 1 and 2 that are never acknowledged. This should really be a function of the underlying *mqtt* package, but for some reason they don't do it. The timeout is 60 seconds, which incorporates sufficient time for several reconnection attempts if the reason for the non-ACK is a broken connection to the broker.
* Templates can now be stored in `mqtt_templates` as YAML files (as before) or (new) ZIP archives containing YAML files. The YAML files can define a single template or multiple.
* Fix docs example in custom template creation.

## 22330

* Improve messages and handling of published topics that aren't acknowledged by the broker.
* Improve docs around custom template creation and use.

## 22326

* Allow templates to be stored in individual files in a `config/mqtt_templates` subdirectory. This should improve users' configuration management for community-contributed templates.
* Additional error checking in install script.

## 22325

* Implement entity deadmarking like other controllers.
* Improve entity initialization/resilience to isolated configuration problems.

## 22324

* Incorporate some device template fixes from @therealdb (with gratitude for his contributions).

## 22323

* Support for deterministic updating of attributes on a topic by using a new/alternate array-based configuration syntax. [[docs](https://reactor.toggledbits.com/docs/MQTTController/#controlling-attribute-evaluation-order)]
* Support for `requires` key in templates to facilitate user-feedback when a template is used but a configuration value required by the template it not provided by the user.

## 22306

* Ease entity ID validation requirements temporarily.

## 22305

* Add methods to allow subscription and publication by other *Controller* instances. [[docs](https://reactor.toggledbits.com/docs/MQTTController/)]

## 22284

**NOTE:** This version requires Reactor version 22280 or higher.

* Add optional default value in topic substitutions. That is, the substitution string `%flavor:chocolate%` would insert the word *chocolate* if *flavor* was not defined in the entity configuration.
* Template `owntracks_in_region` adds a `user` field that can be set if your Owntracks needs it. The Owntracks topic is `/owntracks/user/deviceid`, so the `user` field should be set in your entity configuration (with `topic` and `regionName` to whatever is in that `user` portion of the topic (e.g. if your Owntracks publishes `owntracks/fred/fredsphone` then `topic` should be set to `fredsphone` and `user` should be set to `fred`).
* Code cleanup and sync with Controller base class updates.

## 22260

* Add `owntracks_in_region` template.

## 22150

* Add `tasmota_sensor_flora` template contribution by @Crille

## 22091

* Add hostname to client ID given to the broker -- some brokers (e.g. mosquitto) don't like multiple clients using the same ID, so if we rely only on the controller ID, the user could accidentally create a collision (controller ID is determined by the user config). Adding the hostname should avoid that in most cases. Where it doesn't/can't, the `clientId` can be set in `config.options` for the broker conneection.

## 22086

* Improve excessive-retry detection with mqtt package.

## 22081

* Improve echo config handling for rule states and global variables.
* Trap errors on regular expressions in config and report to log (i.e. don't crash if user enters a bad regexp).

## 22029

* Echo function now publishes rule states and global variable values. Please see the docs linked at top for more details.

## 22024

* Fix command case for Tasmota generic relay (some firmware complains if its not all uppercase)

## 22009

* Allow `entity_identifier` to be set to `id/name` (which is a synonym for `combined`), or `name/id`, the order of the levels being as indicated.

## 22008

* Users may now add the entity name to echo telemetry topics via the `entity_identifier` configuration key (`echo` section); please refer to the documentation for details.

## 21361

* PR 0000280: Fix error thrown on perform when 'entities' key missing from config entirely.

## 21355

* System alerts are now published via `reactor/<controller-id>/alerts`

## 21343

* Add `include_groups` and `exclude_groups` filters for echo selection.
* Default `exclude_capabilities` when *not defined* will filter out extension capabilities.
* Docs updates and fixes.

## 21331

* Detect stalled connections on reconnect (openLuup) and hard-close/recycle. Note that openLuup is not supported as a "production" broker because it does not fully implement the MQTT 3.1.1 standard/requirements.
* More carefully guard sensors (in templates) from payloads that don't contain the sensor data (i.e. avoid setting null value if an update is published with data missing).
* Additional templates for Tasmota and Shelly.
* Documentation updates and clarifications.

## 21321

* Fix incorrect scope reference in *tasmota_generic_relay* payload.
* Additional helpful debug.

## 21320

* The `init` section for device initializations (optional) has been added; refer to the docs.
* The `x_mqtt_device.poll` action is now defined for devices with `query` configured; refer to the docs.
* Allow `username` and `password` in controller config for authentication.

## 21319

* Initial release version; reports at 21313
